## TpCallContent

TpCallContent — proxy object for a call content

## Functions

void | tp_call_content_init_known_interfaces ()
TpCallContentDisposition | tp_call_content_get_disposition ()
TpMediaStreamType | tp_call_content_get_media_type ()
const gchar * | tp_call_content_get_name ()
GPtrArray * | tp_call_content_get_streams ()
void | tp_call_content_remove_async ()
gboolean | tp_call_content_remove_finish ()
void | tp_call_content_send_tones_async ()
gboolean | tp_call_content_send_tones_finish ()

## Properties

TpCallChannel * | channel | Read / Write / Construct Only
TpConnection * | connection | Read / Write / Construct Only
guint | disposition | Read
guint | media-type | Read
char * | name | Read
GPtrArray * | streams | Read

## Signals

void | removed | Run Last
void | streams-added | Run Last
void | streams-removed | Run Last

## Types and Values

| TpCallContent
struct | TpCallContentClass
#define | TP_CALL_CONTENT_FEATURE_CORE

## Object Hierarchy

        GObject
        ╰── TpProxy
            ╰── TpCallContent

## Includes

    #include <telepathy-glib/telepathy-glib.h>

## Description

TpCallContent is a sub-class of TpProxy providing convenient API to represent TpCallChannel's content.

## Functions

### tp_call_content_init_known_interfaces ()

    void
    tp_call_content_init_known_interfaces (void);

Ensure that the known interfaces for TpCallContent have been set up. This is done automatically when necessary, but for correct overriding of library interfaces by local extensions, you should call this function before calling `tp_proxy_or_subclass_hook_on_interface_add()` with first argument `TP_TYPE_CALL_CONTENT`.

Since: 0.17.5

### tp_call_content_get_disposition ()

    TpCallContentDisposition
    tp_call_content_get_disposition (TpCallContent *self);

#### Parameters

self | a TpCallContent |

#### Returns

the value of “disposition”

Since: 0.17.5

### tp_call_content_get_media_type ()

    TpMediaStreamType
    tp_call_content_get_media_type (TpCallContent *self);

#### Parameters

self | a TpCallContent |

#### Returns

the value of “name”

Since: 0.17.5

### tp_call_content_get_name ()

    const gchar *
    tp_call_content_get_name (TpCallContent *self);

#### Parameters

self | a TpCallContent |

#### Returns

the value of “name”

Since: 0.17.5

### tp_call_content_get_streams ()

    GPtrArray *
    tp_call_content_get_streams (TpCallContent *self);

#### Parameters

self | a TpCallContent |

#### Returns

the value of “streams”.

[transfer none][type GLib.PtrArray][element-type TelepathyGLib.CallStream]

Since: 0.17.5

### tp_call_content_remove_async ()

    void
    tp_call_content_remove_async (TpCallContent *self,
                                  GAsyncReadyCallback callback,
                                  gpointer user_data);

Remove the content from the call. This will cause “removed” to be emitted.

#### Parameters

self | a TpCallContent |
callback | a callback to call when the operation finishes |
user_data | data to pass to `callback` |

Since: 0.17.5

### tp_call_content_remove_finish ()

    gboolean
    tp_call_content_remove_finish (TpCallContent *self,
                                   GAsyncResult *result,
                                   GError **error);

Finishes `tp_call_content_remove_async()`.

#### Parameters

self | a TpCallContent |
result | a GAsyncResult |
error | a GError to fill |

Since: 0.17.5

### tp_call_content_send_tones_async ()

    void
    tp_call_content_send_tones_async (TpCallContent *self,
                                      const gchar *tones,
                                      GCancellable *cancellable,
                                      GAsyncReadyCallback callback,
                                      gpointer user_data);

Send `tones` DTMF code on `self` content. `self` must have the `TP_IFACE_CALL_CONTENT_INTERFACE_DTMF` interface.

If DTMF tones are already being played, this request is queued.

#### Parameters

self | a TpCallContent |
tones | a string representation of one or more DTMF events. |
cancellable | optional GCancellable object, `NULL` to ignore |
callback | a callback to call when the operation finishes |
user_data | data to pass to `callback` |

Since: 0.17.5

### tp_call_content_send_tones_finish ()

    gboolean
    tp_call_content_send_tones_finish (TpCallContent *self,
                                       GAsyncResult *result,
                                       GError **error);

Finishes `tp_call_content_send_tones_async()`.

#### Parameters

self | a TpCallContent |
result | a GAsyncResult |
error | a GError to fill |

#### Returns

`TRUE` on success, `FALSE` otherwise.

Since: 0.17.5

## Types and Values

### TpCallContent

    typedef struct _TpCallContent TpCallContent;

Data structure representing a TpCallContent.

Since: 0.17.5

### struct TpCallContentClass

    struct TpCallContentClass {
    };

The class of a TpCallContent.

Since: 0.17.5

### TP_CALL_CONTENT_FEATURE_CORE

    #define             TP_CALL_CONTENT_FEATURE_CORE

Expands to a call to a function that returns a quark for the "core" feature on a TpCallContent.

One can ask for a feature to be prepared using the `tp_proxy_prepare_async()` function, and waiting for it to trigger the callback.

## Property Details

### The `“channel”` property

      “channel”                  TpCallChannel *

The parent TpCallChannel of the content.

Owner: TpCallContent

Flags: Read / Write / Construct Only

Since: 0.17.6

### The `“connection”` property

      “connection”               TpConnection *

The TpConnection of the call.

Owner: TpCallContent

Flags: Read / Write / Construct Only

Since: 0.17.5

### The `“disposition”` property

      “disposition”              guint

The disposition of this content, from TpCallContentDisposition.

Owner: TpCallContent

Flags: Read

Default value: 0

Since: 0.17.5

### The `“media-type”` property

      “media-type”               guint

The media type of this content, from TpMediaStreamType.

Owner: TpCallContent

Flags: Read

Default value: 0

Since: 0.17.5

### The `“name”` property

      “name”                     char *

The name of this content.

Owner: TpCallContent

Flags: Read

Default value: ""

Since: 0.17.5

### The `“streams”` property

      “streams”                  GPtrArray *

GPtrArray of TpCallStream objects. The list of stream objects that are part of this content.

It is NOT guaranteed that `TP_CALL_STREAM_FEATURE_CORE` is prepared on those objects.

Owner: TpCallContent

Flags: Read

Since: 0.17.5

## Signal Details

### The `“removed”` signal

    void
    user_function (TpCallContent *self,
                   gpointer       user_data)

The ::removed signal is emitted when `self` is removed from a TpCallChannel.

#### Parameters

self | the TpCallContent |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 0.17.5

### The `“streams-added”` signal

    void
    user_function (TpCallContent *self,
                   GPtrArray     *streams,
                   gpointer       user_data)

The ::streams-added signal is emitted whenever TpCallStream are added to `self` .

It is NOT guaranteed that `TP_CALL_STREAM_FEATURE_CORE` is prepared on stream objects.

#### Parameters

self | the TpCallContent |
streams | a GPtrArray of newly added TpCallStream. | [type GLib.PtrArray][element-type TelepathyGLib.CallStream]
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 0.17.5

### The `“streams-removed”` signal

    void
    user_function (TpCallContent     *self,
                   GPtrArray         *streams,
                   TpCallStateReason *reason,
                   gpointer           user_data)

The ::streams-removed signal is emitted whenever TpCallStreams are removed from `self` .

It is NOT guaranteed that `TP_CALL_STREAM_FEATURE_CORE` is prepared on stream objects.

#### Parameters

self | the TpCallContent |
streams | a GPtrArray of newly removed TpCallStream. | [type GLib.PtrArray][element-type TelepathyGLib.CallStream]
reason | a TpCallStateReason |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

Since: 0.17.5